title: VIS IWS HK Parameter Lister
author: M.Whillock@ucl.ac.uk
date: 23 Apr 2020

Copyright © 2020 University College London / MSSL

--


# Introduction


This a mini user guide to the VIS IWS TM HK Parameter Lister (parameter_lister1.py) program.

This program generates configuration files to be used in conjuction with the **HK Playback** program (see **Basic\_hk\_playback\_um.pdf**).

## Prerequisites

* python3
* git

## Installation: Online Deployment

TBD

## Installation: Offline Deployment

The parameter lister is currently bundled in with the TM HK Monitor program.

If this has not alrady been done then choose a location to untar the HKTM_monitor gzipped tar file and untar it.

`tar xvfz HKTM_monitor.tar.gz`


## Parameter Lister

This program does not require any conda environment to be set.

### Launching

In an xterm change directory to where the program is installed.
This document assumes that python3 is run using the `python` command.
Use whatever command is required to run python3 on your system.

Launch the program:

`python parameter_lister1.py`

The main window will appear:

![parameter_lister1.py main window](../Pictures/parameter_lister1/main.png)


### Operation

The top-level tab widget with tabs labelled **system** and **packets** allow the user to browse the HK parameters according to the system they refer to or by the HK telemetry packet in which they originate.
These tabs are un-connected with each other: selecting parameters when the **system** tab is selected will not select the corresponding HK parameters in the **packets** tab.
The same principle applies to exporting the selected HK parameters to a file.

#### Parameter Selection And Grouping

A parameter can be selected and de-selected by clicking the mouse in the tick box next to the parameter's name.
Multiple parameters can be selected using shift-click and control-click.
Some parameters are place-holders for multiple related HK parameters
These parameters are greyd out and not selectable; the related HK parameters appear under these place-holders.
An example of this is given below.

![place_holder](../Pictures/parameter_lister1/alt_main.png)

Once a group of parameters has been selected then by clicking the **Group** button the selection will be recorded and an entry placed in the list box on the right.
The new entry consists of a line with a disclosure triangle on the left and the name of the group in the **Parameters** column of the list box.
The name of the group is determined in one of two ways:

- If the selected parameters are related then the group name is the name of the grayed out place-holder.
- If the selected parameters are unrelated then the group name is the name of the first parameter selected.


The original selection will be grayed out.

An example of selecting a related group of parameters is shown in the next two pictures:

![Group selection](../Pictures/parameter_lister1/selection.png)

![Group selection](../Pictures/parameter_lister1/grouped.png)

*Note:* There is currently a limit of 16 parameters per group. If an attempt is made to group more than 16 parameters then an error message will be displayed at the bottom left of the window and the parameters will not be grouped.

##### Group Deselection

A group in the right hand list box can be deleted from the list by clicking on the entry to highlight it and then clicking on the **Delete** button.
The group entry will be deleted from the list box and the parameters in the group will be re-enabled in the original tab from where they were originally selected.

##### Group Disclosure

The parameters of a group in the group list box can shown by clicking the triangular disclosure button of the group's name.
An example of this is given below:

![Group disclosure](../Pictures/parameter_lister1/group_disclosed.png)


#### Parameter Export

The selected grouped parameters can be saved to a csv file by clicking on the **Export** button at any time.
Clicking the **Export** button will bring up a standard file save dialog box if there are any groups in the group list box.
The dialog requires a file name to be entered; this will be the name of the configuration to be used by the **HK Playback** program.
It is recommended not to change directory using the file save dialog; this is because the **HK Playback** program will read the same directory for its configuration files.

The groups are not deleted after an export so the groups can be continually added to.

#### Export Format

Currently the parameters are exported in json format.
This can easily be adapted for any other future format required.

#### Program termination

To quit the program press the **Quit** button.
This will bring up a dialog box confirming the decision to quit.
Pressing **Cancel** in the dialog box will resume the program.
Pressing **Quit** will quit the program.

#### Notes

No use has yet been discovered for the **Clear** button.
No use has yet been discovered for the **Cancel** button.
The **File** menu item is not yet operational.



#### Future Work

- Adapt for multiple export formats with gui format selection.
