from PyQt5 import QtCore, QtWidgets, QtGui
from PyQt5.QtCore import Qt, QMimeData
from PyQt5.QtWidgets import QTreeWidgetItem, QFrame, QFileDialog, QMessageBox
from PyQt5.QtGui import QDrag, QFont


class ListItem(QtWidgets.QListWidgetItem):
    def __init__(self, name, id, src, unit, row):
        super().__init__()
        self.name = name
###        text = '{:25}'.format(name) + '{:10}'.format(id) + '{:14}'.format(src) + '{:2}'.format(unit)
        text = '{:25}'.format(name) + '{:12}'.format(id) + '{:14}'.format(src) + '{:2}'.format(unit)
        self.setText(text)
        self.id = id
        self.src = src
        self.unit = unit
        self.row = row
        self.main_tab = 10     # Unique tab name
        self.sub_tab = 10     # Unique tab name

    def id(self):
        return self.id


    def get_components(self):
        return(self.name, self.id, self.src, self.unit, self.row)


    def row(self):
        '''
        Returns the row (starting from 0) of the selected item.
        '''
        return self.row

    def setSelectable(self):
        pass

    def select(self):
        self.setSelected(True)

    def deselect(self):
        self.setSelected(False)


    def disable(self):
        self.setFlags(Qt.NoItemFlags)


    def enable(self):
        self.setFlags(Qt.ItemIsEnabled | Qt.ItemIsSelectable)
